<?php

error_reporting(E_ALL);

define("GRIP", 21);
define("FILE", "/home/gkruitbo/public_html/joints.txt");

define("ZED_MAX", 800);
define("ZED_MIN", 250);
define("ZED_VAR",  50);

define("ELBOW_MAX", 120);
define("ELBOW_MIN", -60);
define("ELBOW_VAR",  15);

define("YAW_MAX", 90);
define("YAW_MIN", -90);
define("YAW_VAR", 15);

define("PITCH_MAX", 0);
define("PITCH_MIN", -90);
define("PITCH_VAR", 15);

class Joints
{
	function Joints ()
	{
	  // read file
	  $file = explode("\n", file_get_contents(FILE));
		$array = explode(" ", end($file)); //Get last state
		$this->zed      = $array[0];
		$this->shoulder = $array[1];
 		$this->elbow    = $array[2];
		$this->yaw      = $array[3];
		$this->pitch    = $array[4];
		$this->roll     = $array[5];
		$this->grip     = $array[6]; //Or should this be the GRIP, no matter what?
	}
	
	function reset()
	{
		$this->zed      =  300;
		$this->shoulder =  -20;
 		$this->elbow    =   40;
		$this->yaw      =    0;
		$this->pitch    =  -45;
		$this->roll     =    0;
		$this->grip     = GRIP;
	}
	
	function save()
	{
		$fh = fopen(FILE, 'w');
		fwrite($fh, $this->toString());
		fclose($fh);
	}
	
	function move()
	{
	  echo shell_exec("mkdir /home/gkruitbo/public_html/blah"); // " + $this->toString());
	}
	
	function toXML()
	{
	  $return  = "<actions>\n";
	  $return .= "<action type='move' direction='Left'>".$this->canDoString('move', 'Left')."</action>\n";
    $return .= "<action type='move' direction='Right'>".$this->canDoString('move', 'Right')."</action>\n";
	  $return .= "<action type='move' direction='Up'>".$this->canDoString('move', 'Up')."</action>\n";
	  $return .= "<action type='move' direction='Down'>".$this->canDoString('move', 'Down')."</action>\n";
	  $return .= "<action type='look' direction='Left'>".$this->canDoString('look', 'Left')."</action>\n";
	  $return .= "<action type='look' direction='Right'>".$this->canDoString('look', 'Right')."</action>\n";
	  $return .= "<action type='look' direction='Up'>".$this->canDoString('look', 'Up')."</action>\n";
	  $return .= "<action type='look' direction='Down'>".$this->canDoString('look', 'Down')."</action>\n";
	  $return .= "</actions>";
	  return $return;
	}

	function toString()
	{
		return $this->zed . " " . $this->shoulder . " " . $this->elbow . " " . $this->yaw . " " . $this->pitch . " " . 
							$this->roll . " " . $this->grip;
	}
  
  function canDoString($type, $direction)
  {
    if($this->canDo($type, $direction))
      return "true";

    return "false";
  }

  //returns whether the joint can be moved.
  function canDo($type, $direction)
  {
    if($type == "move")
    {
      switch($direction)
      {
        case "Left":
          return $this->elbow < ELBOW_MAX;
        case "Right":
          return $this->elbow > ELBOW_MIN;
        case "Up":
          return $this->zed < ZED_MAX;
        case "Down":
          return $this->zed > ZED_MIN; 
      }
    }
    else
    {
      switch($direction)
      {
        case "Left":
          return $this->yaw < YAW_MAX;
        case "Right":
          return $this->yaw > YAW_MIN;
        case "Up":
          return $this->pitch < PITCH_MAX;
        case "Down":
          return $this->pitch > PITCH_MIN; 
      }
    }
  }
  
	function moveLeft()
	{
		$this->elbow += ELBOW_VAR;
		$this->elbow = min(ELBOW_MAX, $this->elbow);
	}
	
	function moveRight()
	{
		$this->elbow -= ELBOW_VAR;
		$this->elbow  = max(ELBOW_MIN, $this->elbow);
	}
	
	function moveUp()
	{
		$this->zed += ZED_VAR;
		$this->zed = min(ZED_MAX, $this->zed);
	}
	
	function moveDown()
	{
		$this->zed -= ZED_VAR;
		$this->zed = max(ZED_MIN, $this->zed);
	}
	
	function lookUp()
	{
		$this->pitch += PITCH_VAR;
		$this->pitch = min(PITCH_MAX, $this->pitch);
	}
	
	function lookDown()
	{
		$this->pitch -= PITCH_VAR;
		$this->pitch = max(PITCH_MIN, $this->pitch);
	}
	
	function lookLeft()
	{
		$this->yaw += YAW_VAR;
		$this->yaw = min(YAW_MAX, $this->yaw);
	}
	
	function lookRight()
	{
	  $this->yaw -= YAW_VAR;
		$this->yaw = max(YAW_MIN, $this->yaw);
	}
}
?>
