// Web cam controls 'n shit.
function Webcam(imgElem, ctrlHref, imgHref, timeout)
{
  var me = this;
  document.body.addEventListener("click", 
                                 function _hClick(e) { me.handleClick(e); },
                                 true);
  
  // Refresh webcam image every 5 seconds
  setInterval(function (me) { me.refreshWebcam() } , timeout, this);

  this.image = imgElem;
  this.ctrlHref = ctrlHref;
  this.imgHref = imgHref;
  return this;
}

Webcam.prototype.href = "";

// Turns
Webcam.prototype.move =
function wc_move(type, direction)
{
  var me = this;
  this.req(this.ctrlHref + "type=" + type + "&direction=" + direction,
           function xhr_cb(txt) { me.updateMoveStatus(txt); } );
}

Webcam.prototype.reset =
function wc_reset()
{
  var me = this;
  this.req(this.ctrlHref + "type=reset",
           function xhr_cb(txt) { me.updateMoveStatus(txt); });
}

Webcam.prototype.req = 
function wc_req(href, cb)
{
  var me = this;
  req = new XMLHttpRequest();
  req.overrideMimeType('text/xml');
  req.onreadystatechange =
    function orsc() {
      if (req.readyState == 4 && req.status == 200) {
        if (cb)
          cb.apply(me, [req.responseText]);
      }
    }
  req.open('GET', href, true);
  req.send(null);
}

Webcam.prototype.handleClick = 
function wc_handleClick(e)
{
  var origID = e.originalTarget.id;

  // Return if we didn't actually click an arrow:
  var m = origID.match(/(look|move)(up|down|left|right)/i)
  if (!m)
  {
    var reset = (origID == "reset");
    var refresh = (origID == "refresh");
    if (reset)
      this.reset();
    else if (refresh)
      this.refreshWebcam();
    return;
  }

  // call appropriate function:
  this.move(m[1], m[2]);
}

Webcam.prototype.refreshWebcam =
function wc_refreshWebcam()
{
  this.image.removeAttribute("src");
  this.image.setAttribute("src", this.imgHref + "?" + Date.now());
}

Webcam.prototype.updateMoveStatus =
function wc_update(txt)
{
  txt = txt.replace(/<\?xml[^>]*>/, "");
  var actions = new XML(txt);
  // Update buttons
  var b = document.getElementById("moveUp");
  b.disabled = (actions.action.(@type=='move'&&@direction=='Up') == "false");

  
  b = document.getElementById("moveDown");
  b.disabled = (actions.action.(@type=='move'&&@direction=='Down') == "false");
  
  
  b = document.getElementById("moveRight");
  b.disabled = (actions.action.(@type=='move'&&@direction=='Right') == "false");
  
  
  b = document.getElementById("moveLeft");
  b.disabled = (actions.action.(@type=='move'&&@direction=='Left') == "false");
  
  
  b = document.getElementById("lookUp");
  b.disabled = (actions.action.(@type=='look'&&@direction=='Up') == "false");
  
  
  b = document.getElementById("lookDown");
  b.disabled = (actions.action.(@type=='look'&&@direction=='Down') == "false");
  
  
  b = document.getElementById("lookRight");
  b.disabled = (actions.action.(@type=='look'&&@direction=='Right') == "false");
  
  
  b = document.getElementById("lookLeft");
  b.disabled = (actions.action.(@type=='look'&&@direction=='Left') == "false");
  return;
}
